<template>
    <div class="remark">
        <div class="remark-header row items-center col-12">
            <div
                class="
                    q-pl-md
                    helvetica-neue-medium
                    row
                    items-center
                    font-16
                    col-10
                    text-white
                    note-header
                "
            >
                <span>{{ $t('home.remark') }}</span>
                <q-btn
                    v-if="clickEdit"
                    flat
                    text-color="white"
                    size="sm"
                    icon="img:icons\edit-icon.png"
                    @click="editNote()"
                />
                <q-btn
                    v-if="!clickEdit"
                    flat
                    text-color="white"
                    icon="save"
                    @click="createNote()"
                />
            </div>
            <div class="col-2 row justify-end">
                <q-btn
                    flat
                    text-color="white"
                    size="md"
                    icon="clear"
                    @click="closeDrawer(false)"
                />
            </div>
            <!-- <div class="col-2 row justify-end q-pr-md">
                <q-btn
                    v-if="clickEdit"
                    flat
                    text-color="white"
                    size="sm"
                    icon="img:icons\edit-icon.png"
                    @click="editNote()"
                />
                <q-btn
                    v-if="!clickEdit"
                    flat
                    text-color="white"
                    icon="save"
                    @click="createNote()"
                />
            </div> -->
            <!-- <div
                class="
                    offset-7
                    q-pr-md
                    helvetica-neue-medium
                    font-14
                    row
                    justify-center
                "
            > -->
            <!-- Edit -->
            <!-- <q-btn
                    v-if="clickEdit && permissions.remark?.update"
                    no-caps
                    text-color="white"
                    :label="$t('button.edit')"
                    class="button-edit"
                    @click="editNote()"
                /> -->

            <!-- Save Changes -->
            <!-- <q-btn
                    v-if="!clickEdit && permissions.remark?.create"
                    no-caps
                    text-color="white"
                    :label="$t('button.save')"
                    class="button-save"
                    @click="createNote()"
                />
            </div> -->
        </div>

        <!-- Note Textarea -->
        <div class="remark-scroll col-12 q-pa-md">
            <q-input
                autogrow
                borderless
                v-model="state.notes"
                :readonly="!status"
                type="textarea"
            />
        </div>

        <!-- <div
            v-else
            class="remark-scroll col-12 row justify-center items-center q-pt-md"
            <div class="row justify-center items-center">
                <q-icon size="lg" name="img:icons\pen.png" @click="editNote"></q-icon>
                <span
                    class="
                        row
                        justify-center
                        items-center
                        helvetica-neue
                        font-14
                        col-12
                        q-pt-sm
                    "
                >
                    {{ $t('home.noNote') }}
                </span>
            </div>
        </div> -->
    </div>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
/* eslint-disable @typescript-eslint/no-unsafe-call */ /* eslint-disable
@typescript-eslint/no-unsafe-member-access */ /* eslint-disable
@typescript-eslint/no-unsafe-assignment */ /* eslint-disable
@typescript-eslint/no-explicit-any*/ /* eslint-disable
@typescript-eslint/no-floating-promises */ /* eslint-disable
@typescript-eslint/no-misused-promises */ /* eslint-disable
@typescript-eslint/require-await */

import { defineComponent, reactive, ref, computed, watch } from 'vue';
import { mapGetters } from 'vuex';
import { useStore } from 'src/store';

export default defineComponent({
    name: 'RemarkList',
    computed: {
        ...mapGetters({
            noteList: 'customer/getNoteList',
            permissions: 'role/getPermissions',
            noteDrawer: 'menu/getNoteDrawer'
        })
    },
    setup() {
        // data
        const store = useStore();

        // computed
        const selectedUserId = computed(() => {
            return store.state.conversation.selectedUserID;
        });

        const stateNote = computed(() => {
            return store.state.note.note.text;
        });

        // watch
        watch(selectedUserId, () => {
            state.notes = '';
            if (selectedUserId.value) {
                status.value = false;
                clickEdit.value = true;
                getNoteByUserID();
            }
        });

        let state = reactive({
            notes: '',
            userId: '' as string | undefined
        });

        let clickEdit = ref(true);
        let status = ref(false);

        // methods
        const editNote = () => {
            clickEdit.value = false;
            status.value = true;
        };

        const getNoteByUserID = async () => {
            const result = await store.dispatch('note/getNoteByUserID', {
                userId: selectedUserId.value
            });
            if (result) {
                state.notes = store.state.note.note.text;
            }
        };

        const createNote = async () => {
            const result: any = await store.dispatch('note/editNote', {
                userId: selectedUserId.value,
                note: state.notes
            });
            state.notes = result.result.note.text;
            clickEdit.value = true;
            status.value = false;
            store.dispatch('menu/setNoteDrawer', false);
        };

        const closeDrawer = (status: boolean) => {
            store.dispatch('menu/setNoteDrawer', status);
        };

        return {
            state,
            editNote,
            clickEdit,
            status,
            createNote,
            getNoteByUserID,
            selectedUserId,
            stateNote,
            closeDrawer
        };
    }
});
</script>
